//***************************************************************************************************************************
/********************************************************g*******************************************************************
 **                                                                                                                         **
 **                       BUTTONS / KNÖPFE                                                                                  **
 **                                                                                                                         **
 **   Hier befindet sich die Klasse für Buttons, die uns das erstellen von Knöpfen vereinfacht                              **
 **                                                                                                                         **
 ****************************************************************************************************************************/
//***************************************************************************************************************************



/*/************************************************************************************************************************************
 **                                                                                                                                  **
 **                                      Button Klasse, die berechnet ob der Button gedrückt wird und den Button erleuchten lässt    **
 **                                                                                                                                  **
 //************************************************************************************************************************************/
class Button {

  String buttonName;    // Button Name & Text
  int posX;             // X-Kooordinate 
  int posY;             // Y-Koordinate
  color buttonColor;    // Buttonfarbe normal (Buttonzustand 1)
  color buttonHoverColor;// Buttonfarbe wenn die Maus übergeht (Buttonzustand 2)
  color clickedColor;    // Buttonfarbe angeklickt (Buttonzustand 3)

  int buttonWidth;        // Boxlänge
  int buttonHeight;       // Boxhöhe

  color textColor;      // Textfarbe
  int textSize;         // Schriftartengrösse

  // Klassenkonstruktor der die Werte setzt
  Button(String buttonName, int posX, int posY, color buttonColor, color buttonHoverColor, color clickedColor, int buttonWidth, int buttonHeight, color textColor, int textSize) {

    this.buttonName = buttonName;

    this.posX = posX;
    this.posY = posY;
    this.buttonWidth = buttonWidth;
    this.buttonHeight = buttonHeight;

    this.buttonColor = buttonColor;
    this.buttonHoverColor = buttonHoverColor;
    this.clickedColor = clickedColor;

    this.textColor = textColor;
    this.textSize = textSize;
  }


  // mode 1 = normal, mode 2 = hovered, mode 3 = clicked
  // Funktion um den Button anzeigen zu lassen
  void draw(int mode, boolean playSound) {
    color finalColor = color(0, 0, 0);                     // Buttonhintergrundfarbe zu der gewechselt wird
    color finalStrokeColor = color(0, 0, 0);               // Buttonrandfarbe zu der gewechselt wird

    switch(mode) {                                         // Je nach Buttonzustand werden andere Farben gewählt
    case 1:  //////////////////////////////// KNOPFZUSTAND 1
      finalColor = this.buttonColor;
      finalStrokeColor = this.buttonColor;
      break;
    case 2: //////////////////////////////// KNOPFZUSTAND 2
      finalColor = this.buttonColor;
      finalStrokeColor = this.buttonHoverColor;
      break;
    case 3: //////////////////////////////// KNOPFZUSTAND 3
      finalColor = this.clickedColor;
      finalStrokeColor = this.clickedColor;
      if (playSound) hoverSound.play();                    // Falls playSound true ist, wird ein Sound abgespielt
      break;
    }

    // Buttonbox wird gezeichnet
    stroke(finalStrokeColor);                               
    fill(finalColor);
    rectMode(CENTER);
    rect(this.posX, this.posY, this.buttonWidth, this.buttonHeight);
    
    // Buttontext wird gezeichnet
    fill(this.textColor);                                
    textFont(mono);
    textSize(this.textSize);
    textAlign(CENTER);
    text(this.buttonName, this.posX, this.posY+textSize/2);
  }

  // Funktion, die schaut, ob die Maus auf dem Button ist
  boolean mouseOnIt() {
    int x = mouseX;
    int y = mouseY;

    if (! (x > (posX-buttonWidth/2) && x < (posX+buttonWidth/2) && y > (posY-buttonHeight/2) && y < (posY+buttonHeight/2)) ) { // Falls sich die Maus darauf befindet, wird der Button angeleuchtet
      this.draw(1, true); // Button wird angeleuchtet, da die Maus sich über ihm befindet
    }

    return (x > (posX-buttonWidth/2) && x < (posX+buttonWidth/2) && y > (posY-buttonHeight/2) && y < (posY+buttonHeight/2));
  }

  // Funktion, die schaut, ob die Maus auf dem Button ist mit gameState Bedingung
  boolean mouseOnIt(int gameStateNeeded) {
    int x = mouseX;
    int y = mouseY;

    boolean correctSection = (x > (posX-buttonWidth/2) && x < (posX+buttonWidth/2) && y > (posY-buttonHeight/2) && y < (posY+buttonHeight/2)); // Falls sich die Maus darauf befindet, wird der Button angeleuchtet
    if (!correctSection) {
      if (gameState == gameStateNeeded) this.draw(1, true);  // Button wird angeleuchtet, da die Maus sich über ihm befindet
    }

    return ((correctSection) && gameStateNeeded == gameState);
  }
}

/*/************************************************************************************************************************************
 **                                                                                                                                  **
 **                                                        Funktion, die das Klicken auf Buttons verwaltet                           **
 **                                                                                                                                  **
 //************************************************************************************************************************************/
void menuClickHandler(boolean clicked) {
  if (clicked) println("X:", mouseX, "Y:", mouseY); // DEBUG


  if (!clicked) { ////////////////////////////////////// FALLS DIE MAUS NUR ÜBER DEN BUTTON GEHT ABER NICHT DRÜCKT /////////////////////

    if (playButton.mouseOnIt(0)) playButton.draw(2, true);
    if (shopButton.mouseOnIt(0)) shopButton.draw(2, true);
    if (quitButton.mouseOnIt(0)) quitButton.draw(2, true);
    if (settingsButton.mouseOnIt(0)) settingsButton.draw(2, true);
    if (settingsDelete.mouseOnIt(2)) settingsDelete.draw(2, true);
    if (backButton.mouseOnIt(2) || backButton.mouseOnIt(3)) backButton.draw(2, true);
    if (shopItem1.mouseOnIt(3)) shopItem1.draw(2, true);
    if (shopItem2.mouseOnIt(3)) shopItem2.draw(2, true);
    if (shopItem3.mouseOnIt(3)) shopItem3.draw(2, true);
  } else { ////////////////////////////////////// FALLS DIE MAUS AUF DEN BUTTON DRÜCKT  ////////////////////////////////////////////////

    if (shopItem1.mouseOnIt(3)) { // SHOP ITEM 1
      buyItem(1);         // Item 1 wird gekauft
      gameState=0;        // Gamestate wird gewechselt                 
      createScreen(true); // Gamestate wird aktualisiert
      return;
    } else if (shopItem2.mouseOnIt(3)) { // SHOP ITEM 2
      buyItem(2);        // Item 2 wird gekauft...
      gameState=0;       // `
      createScreen(true);// `
      return;
    } else if (shopItem3.mouseOnIt(3)) { // SHOP ITEM 3
      buyItem(3);       // `
      gameState=0;      // `
      createScreen(true);// `
      return;
    }

    if (playButton.mouseOnIt(0)) { // PLAY BUTTON
      playButton.draw(3, true); 
      gameState = 5;            // Animation wird gestartet
      createScreen(true);       // Gamestate wird aktualisiert
      return;
    }

    if (shopButton.mouseOnIt(0)) { // SHOP BUTTON (IM HAUPTMENÜ)
      shopButton.draw(3, true);
      gameState = 3;           // Es wird zu Shopstate gewechselt
      createScreen(true);
      delay(100);
      return;
    }

    if (settingsButton.mouseOnIt(0)) { // SETTINGS BUTTON
      settingsButton.draw(3, true);
      gameState = 2;
      createScreen(true);
      return;
    }

    if (settingsDelete.mouseOnIt(2)) { // SPIELSTAND LÖSCHEN BUTTON
      settingsButton.draw(3, true);
      deleteGameData();  // data.txt wird gelöscht
      loadGameData();    // neues data.txt wird erstellt
      gameState = 0;
      createScreen(true);
      return;
    }

    if (backButton.mouseOnIt(2) || backButton.mouseOnIt(3) || backButton.mouseOnIt(4)) { // ZUERECK ZUM MENU BUTTON
      gameState = 0;
      createScreen(true);
      return;
    }

    if (quitButton.mouseOnIt(0)) { // QUIT BUTTON
      exit();   // Spiel wird geschlossen
      return;
    }
  }
}

void buyItem(int item) {
  loadGameData(); // Münzen werden aus der Datei geladen
  
  switch(item) {  // Switch-Statement für welchen Gegenstand man versucght zu kaufen
  case 1:
    if (coins >= shopItem1Price && !boughtItem1) { // Überprüfung ob man genug Geld hat & Gegenstand noch nicht gekauft wurde
      coins-=shopItem1Price;                       // Preis wird abgezogen 
      boughtItem1 = true;                          // Item 1 ist nun gekauft
      saveGameData();                              // Daten werden in Datei gespeichert
      cashSound.play();                            // Kaufsound wird abgespielt
    }
    break;
  case 2:
    if (coins >= shopItem2Price && !boughtItem2) { // Überprüfunng ob man genug Geld hat & `
      coins-=shopItem2Price;                       //
      boughtItem2 = true;                          //
      saveGameData();                              //
      cashSound.play();                            //
    }
    break;
  case 3:
    if (coins >= shopItem3Price && !boughtItem3) { // Überprüfunng ob man genug Geld hat & `
      coins-=shopItem3Price;                       //
      boughtItem3=true;                            //
      saveGameData();                              //
      cashSound.play();                            //
    }
    break;
  }
}
