//***************************************************************************************************************************
/********************************************************g*******************************************************************
 **                                                                                                                         **
 **                       HIGHSCORE                                                                                         **
 **                                                                                                                         **
 **   Hier befindet sich die Klasse für Buttons, die uns das erstellen von Knöpfen vereinfacht                              **
 **                                                                                                                         **
 ****************************************************************************************************************************/
//***************************************************************************************************************************

int highscore = 0;
int coins = 0;
boolean boughtItem1, boughtItem2, boughtItem3 = false;

/*/************************************************************************************************************************************
 **                                                                                                                                  **
 **                                          Funktion, die die Scores & Shop Daten in der Datei speichert                            **
 **                                                                                                                                  **
 //************************************************************************************************************************************/
void saveGameData() {
  // Öffne die "data.txt" Datei im Schreibmodus
  PrintWriter writer = createWriter("data.txt");
  // Schreibe den Highscore und die Coins in die Datei
  writer.println(highscore); 
  writer.println(coins);
  writer.println(boughtItem1);
  writer.println(boughtItem2);
  writer.println(boughtItem3);
  // Schließe die Datei
  writer.close();
}

/*/************************************************************************************************************************************
 **                                                                                                                                  **
 **                                          Funktion, die die Daten aus der Datei ladet                                             **
 **                                                                                                                                  **
 //************************************************************************************************************************************/
void loadGameData() {
  // Versuche die "data.txt" Datei zu öffnen
  BufferedReader reader = createReader("data.txt");
  if (reader != null) {
    try {
      // Lese den Highscore aus der Datei
      String scoreStr = reader.readLine();
      // Konvertiere den String in eine Zahl
      highscore = Integer.parseInt(scoreStr);
      // Lese die Coins aus der Datei
      String coinsStr = reader.readLine();
      // Konvertiere den String in eine Zahl
      coins = Integer.parseInt(coinsStr);
      // Schließe die Datei
      
      String boughtItem1Str = reader.readLine();
      boughtItem1 = Boolean.parseBoolean(boughtItem1Str);
      String boughtItem2Str = reader.readLine();
      boughtItem2 = Boolean.parseBoolean(boughtItem2Str);
      String boughtItem3Str = reader.readLine();
      boughtItem3 = Boolean.parseBoolean(boughtItem3Str);
      
      reader.close();
    } 
    catch (IOException e) {
      println("Fehler beim Lesen der Datei: " + e.getMessage());
    }
  } else {
    // Wenn die Datei nicht existiert, erstelle sie und schreibe den Highscore (0) und die Coins (0) hinein
    saveGameData();
  }
}
/*/************************************************************************************************************************************
 **                                                                                                                                  **
 **                                          Funktion, die die Daten Datei löscht                                                    **
 **                                                                                                                                  **
 //************************************************************************************************************************************/
void deleteGameData() {
  // Lösche die "data.txt" Datei, falls sie vorhanden ist
  File file = new File(sketchPath("data.txt"));
  if (file.exists()) {
    file.delete();
  }
  // Setze den Highscore und die Coins auf 0
  highscore = 0;
  coins = 0;
}
