//***************************************************************************************************************************
/********************************************************g*******************************************************************
 **                                                                                                                         **
 **                       LEVELS                                                                                            **
 **                                                                                                                         **
 **   Hier werden die Hintergrundbilder und Gegner der Levels verwalten                                                     **
 **                                                                                                                         **
 ****************************************************************************************************************************/
//***************************************************************************************************************************

void spawnObstacles() {
  switch(theme) {
  case 1: // DRAUSSEN / AUSSERHALB SCHULE
    if (ticker-tickSaveTheme <= 1) {                       // nur 1x-mal
      bg3 = loadImage("images/themes/building.jpg");
      bg3R = loadImage("images/themes/building-r.jpg");
      bg2 = loadImage("images/themes/mountain_layer.png");
      bg1 = loadImage("images/themes/tree_layer.png");
    }
    spawnOutsideElements();
    break;
  case 2: // GANG
    if (ticker-tickSaveTheme <= 1) {                       // nur 1x-mal
      bg3 = loadImage("images/themes/gang.jpeg");
      bg3R = loadImage("images/themes/gang-r.jpeg");
      bg2 = loadImage("images/themes/gang_layer.png");
      bg1 = loadImage("images/themes/gang_floor.png");
    }
    if (ticker % 60 == 0 && random(0, 100) <= 50) {        // Alle 60 Frames mit 50% Chance wird ein Lehrer erschaffen
      spawnRandomTeacher();  
    } else if (ticker % 180 == 0 && random(0, 100) < 30) {
      spawnTable();                                        // Alle 180 Frames mit 30% Chance wird falls kein Lehrer erschaffen wird ein Tisch erschaffen
    }
    break;
  case 3: // KLASSENZIMMER
    if (ticker-tickSaveTheme <= 1) {                       // nur 1x-mal
      bg3 = loadImage("images/themes/klassenzimmer.jpg");
      bg3R = loadImage("images/themes/klassenzimmer-r.jpg");
      bg2 = loadImage("images/themes/klassenzimmer_layer.png");
      bg1 = loadImage("images/themes/klassenzimmer_floor.png");
    }
    spawnFurniture();                                      // Möbel wird erschaffen
    break;
  case 4:// KRAFTRAUM
    if (ticker-tickSaveTheme <= 1) {                       // nur 1x-mal
      bg3 = loadImage("images/themes/kraftraum.jpeg");
      bg3R = loadImage("images/themes/kraftraum-r.jpeg");
      bg2 = loadImage("images/themes/gym_layer.png");
      bg1 = loadImage("images/themes/gym_floor.png");
    }
    spawnGymElements();                                   // Gymelemente werden erschaffen
    break;
  case 5: // MENSA
    if (ticker-tickSaveTheme <= 1) {                       // nur 1x-mal
      bg3 = loadImage("images/themes/mensa.jpeg");
      bg3R = loadImage("images/themes/mensa-r.jpeg");
      bg2 = loadImage("images/themes/mensa_layer.png");
      bg1 = loadImage("images/themes/mensa_floor.png");
    }
    spawnFood();                                          // Essensgegner werden erschaffen
    break;
  }
}

void spawnTable() {
  if (Math.round(random(1, 2)) == 1) { // 50% Chance
    Enemy tisch = new Enemy("Tisch", "images/enemys/objects/depressionTable.png", int(random(2, 8))); // Tischelement das Schaden macht
    tisch.spawn(); // Tisch erschaffen
  } else {
    Solid tisch = new Solid("Tisch", "images/enemys/objects/lehrerpult.png", int(random(4, 15))); //  Tischelement das solide ist
    tisch.spawn(); // Tisch erschaffen
  }
}

void spawnFood() {
  if ((frameCount % 100 == 0) && random(0, 100) > 30) {                                                     // Delay & Chance
    Enemy food = new Enemy("Essen", "images/enemys/food/food-" + Math.round(random(0, 97)) + ".png", 10);   // Enemyelement
    food.resizeFactor(2.2, 2.2); // Bild wird resized
    food.obstacleY+=10;          // Y-Wert korrigiert
    food.spawn();                // Wird erschaffen
  }
  if (frameCount % 60*50 == 0 && int(random(0, 10)) <= 2) spawnRandomTeacher(); // Das gleiche auch hier
  if (frameCount % 60*30 == 0 && int(random(0, 10)) <= 1) spawnWoodStair(); // Das gleiche auch hier
}

//
// Ab hier keine Kommentare mehr, da das Prinzip überall gleich ist
//

void spawnWoodStair() {
  for (int i = 0; i < 3; i++) {
    for (int b=0; b < i+1; b++) {
      Solid holzKiste = new Solid("Holzkiste", "images/enemys/objects/kiste.png", 6);
      holzKiste.spawn();
      holzKiste.resizeFactor(0.6, 0.6);
      holzKiste.obstacleX = holzKiste.obstacleX + ((holzKiste.obstacleImg.width+200)*i);
      holzKiste.obstacleY = holzKiste.obstacleY - (holzKiste.obstacleImg.height*b);
    }
  }
}

void spawnFurniture() {
  String[] possFurnitureElements = new String[]{"bookshelf.png", "lehrerpult.png", "schrank.png", "schrank2.png", "schrank3.png"};
  if (frameCount % 120 == 0 && int(random(0, 100)) < 50) {
    String fString = possFurnitureElements[int(random(0, possFurnitureElements.length))];
    Enemy furniture = new Enemy("Möbel", "images/enemys/objects/" + fString, int(random(4, 10)));
    furniture.spawn();
  }
}

void spawnGymElements() {
  String[] possGymElements = new String[]{"bank", "beinpresse", "beinstrecke", "hantelbank", "kabelzug", "langhantel", "laufband", "laufrad", "multigym"};
  if (ticker % 40 == 0 && random(0, 100) < 40) {
    if (!(int(random(1, 10)) == 1)) {
      Obstacle element = new Enemy("Gymelement", "images/enemys/objects/"+possGymElements[int(random(0, possGymElements.length))]+".png", 6);
      element.resizeFactor(0.9, 0.9);
      element.spawn();
    } else if (random(1, 100) < 30) {
      String teacherImageName = "sport";
      String teacherName = "Sportlehrer";

      Obstacle teacherObject = new Enemy(teacherName, "/images/enemys/teachers/" + teacherImageName + ".png", 6);
      teacherObject.spawn();
      teacherObject.showName();
    } else if ((random(1, 100) > 50)) {
      spawnWoodStair();
    } else {
      PowerUp trampolin = new PowerUp("Trampolin", "/images/enemys/objects/trampolin.png", 6, 0);
      trampolin.resizeFactor(0.06, 0.06);
      trampolin.spawn();
    }
  }
}

void spawnOutsideElements() {

  if (ticker % 80 == 0 && random(0, 100) < 40) {
    if (int(random(1, 2)) == 1) {
      if (int(random(1, 5)) == 1) {
        Obstacle holzKiste = new Enemy("Holzkiste", "images/enemys/objects/kiste.png", 6);
        holzKiste.resize(50, 50);
        holzKiste.spawn();
        holzKiste.obstacleX = holzKiste.obstacleX + int(random(0, 300));
      } else {
        Obstacle holzKiste = new Enemy("Holzkiste", "images/enemys/objects/kiste.png", 6);
        holzKiste.resize(50, 50);
        holzKiste.spawn();
      }
    } else spawnRandomTeacher();
  }

  if (ticker % 110 == 0 && random(0, 100) < 10) {
    Obstacle bus = new Enemy("Bus", "images/enemys/objects/bus.png", int(random(10, 15)));
    bus.resizeFactor(0.8, 0.8);
    bus.spawn();
  }
}

void spawnRandomTeacher() {
  // Hier wird ein Randombild ausgewählt
  String[] teachers = new String[]{"abwart-Abwart", "bio-Biolehrer", "chemie-Chemielehrer", "geografie-Geografielehrer", "info-Informatiklehrer", "mathe-Mathematiklehrer", "musik-Musiklehrer", "rektor-Rektor", "rektor-Prorektor", "sport-Sportlehrer"};

  String teacher = teachers[int(random(0, teachers.length))];
  String teacherImageName = teacher.split("-")[0];
  String teacherName = teacher.split("-")[1];

  Obstacle teacherObject = new Enemy(teacherName, "/images/enemys/teachers/" + teacherImageName + ".png", 6);
  teacherObject.spawn();
}
