//***************************************************************************************************************************
/********************************************************g*******************************************************************
 **                                                                                                                         **
 **                       Obstacles                                                                                         **
 **                                                                                                                         **
 **   Hier befinden sich alle Obstacle Funktionen & Klassen die von der Hauptklasse Obstacle erben                          **
 **                                                                                                                         **
 ****************************************************************************************************************************/
//***************************************************************************************************************************


/*/************************************************************************************************************************************
 **                                                                                                                                  **
 **                      Code der für die Berührungen & Hitboxen der Objetke verantwortlich ist)                                     **
 **                                                                                                                                  **
//************************************************************************************************************************************/
void obstacleHandler() {
  for (int i = 0; i < obstacles.size(); i++) {                         // For Schleife durch alle Elemente
    Obstacle currentObstacle = obstacles.get(i);                       // Obstacle in der Schleife

    if (currentObstacle != null) {

      // Hitboxes Obstacle nur zum Debuggen
      if (showHitboxes) showDebugRect(color(255, 0, 0), int(currentObstacle.obstacleX), int(currentObstacle.obstacleY), currentObstacle.obstacleImg.width, currentObstacle.obstacleImg.height);
      if (showHitboxes) showDebugRect(color(255, 0, 0), int(player.x-player.playerImg.width/2), int(player.y-player.playerImg.height/2), player.playerImg.width, player.playerImg.height);

      currentObstacle.obstacleX -= currentObstacle.obstacleSpeed;      // Obstacle-X wird mit Obastclespeed verändert
      if (currentObstacle.obstacleX < -100) obstacles.remove(currentObstacle); // Falls das Obstacle aus dem Fenster geht, wird es gelöscht

      image(currentObstacle.obstacleImg, currentObstacle.obstacleX, currentObstacle.obstacleY);
      if (currentObstacle.showName) { // Falls der boolean true ist, wird über dem Objekt der Name angezeigt
        textSize(10);
        fill(#FFFFFF);
        textAlign(CENTER);
        text(currentObstacle.obstacleName, currentObstacle.obstacleX, currentObstacle.obstacleY-30);
      }

      // DEBUGMODE
      if (showHitboxes) {
        showDebugRect(color(255, 255, 255), int(player.x-player.playerImg.width/2), int(player.y+player.playerImg.height/2), player.playerImg.width, 1);
        showDebugRect(color(255, 255, 255), int(currentObstacle.obstacleX), int(currentObstacle.obstacleY), currentObstacle.obstacleImg.width, 1);
        text(currentObstacle.obstacleImg.width + "x"+ currentObstacle.obstacleImg.height, currentObstacle.obstacleX, currentObstacle.obstacleY-20);
        textAlign(LEFT);
        fill(255, 0, 0);
        textSize(10);
        text("canJump: " + player.canJump, 40, 100);
        text("gameTicker: " + gameTicker, 40, 100+20);
        text("tickSaveTheme: " + tickSaveTheme, 40, 100+40);
        text("herzen: " + herzen, 40, 100+60);
        text("levelTime: " + levelTime, 40, 100+80);
        text("theme: " + theme, 40, 100+100);
        text("obstacles length: " + obstacles.size(), 40, 100+120);
        text("alreadyThemesBeen length: " + alreadyThemesBeen.size(), 40, 100+140);
        text("player gravity: " + player.gravity, 40, 100+160);
        text("player x: " + player.x, 40, 100+180);
        text("player y: " + player.y, 40, 100+200);
        text("player speed: " + player.speed, 40, 100+220);
        text("player crouch: " + player.crouch, 40, 100+240);
        text("player animation: " + player.currentImage, 40, 100+260);
        text("framecount: " + frameCount, 40, 100+280);
        text("framerate: " + frameRate, 40, 100+300);
        text("jumpcount: " + jumpCount, 40, 100+320);
      }


      // Kollisionserkennung
      if (player.x + player.playerImg.width/2 >= currentObstacle.obstacleX && player.x <= currentObstacle.obstacleX + currentObstacle.obstacleImg.width &&
        player.y + player.playerImg.height/2 >= currentObstacle.obstacleY) {

        if (player.y+player.playerImg.height/2-10 <= currentObstacle.obstacleY && currentObstacle instanceof Solid) { // Falls der Spieler über dem Objekt ist und das Objekt solide ist
          player.y-=10;                                                                                               // Spieler wird hochgedrückt / Steht auf dem Objekt
          player.canJump = true;                                                                                      // Spieler kann wieder springen
          if (showHitboxes) {                                                                                         // DEBUGMODE
            imageMode(CENTER);
            image(up, player.x, player.y);
            imageMode(CORNER);
          }
        }
        //else if (currentObstacle instanceof Solid) {
        //  player.canJump = false;
        //  if (player.x+player.playerImg.width/2+5 >= currentObstacle.obstacleX) {
        //    player.x-=currentObstacle.obstacleSpeed*2-1;
        //    player.canJump = true;
        //    if (showHitboxes) {
        //      imageMode(CENTER);
        //      image(left, player.x+player.playerImg.width/2+5, player.y);
        //      imageMode(CORNER);
        //    }
        //  } else player.canJump = false;
        //}

        currentObstacle.collide();
      }
    }
  }
}


// Funktion die jede 100 Frames mit 50% Chance einen Coin erschafft
void spawnCoin() {
  if (!(ticker % 100 == 0 && random(0, 100) > 50)) return;
  Obstacle c = new Coin("Coin", "images/coin.png", 5);
  c.resize(30, 30);
  c.spawn();
}



abstract class Obstacle {

  String obstacleName; // Name
  String obstacleImage;// Bilddateipfad
  PImage obstacleImg;  // Bild
  int obstacleX;       // X
  int obstacleY;       // Y
  int obstacleSpeed;   // Geschwindigkeit
  boolean showName = false; // Wert ob der Name angezeigt werden soll

  Obstacle(String obstacleName, String obstacleImage, int obstacleSpeed) {  //////////////////////////////////////////////////////////////////////// VORLAGE / MUTTERKLASSE / ABSTRAKTE KLASSE 
    this.obstacleName = obstacleName;
    this.obstacleImage = obstacleImage;
    this.obstacleX = width+50;
    this.obstacleSpeed = obstacleSpeed;

    obstacleImg = loadImage(obstacleImage);
    int imgHeight = obstacleImg.height;

    this.obstacleY = height-imgHeight;
    
    if (showHitboxes) { // Falls Debugmode aktiv ist, wird der Name angezeigt
      this.showName = true;
      this.obstacleName = obstacleImage;
    }
  }

  void spawn() { // .spawn fügt das Obstacle der Liste zu
    obstacles.add(this);
  }

  void resize(int w, int h) { // Obstaclebild resizen
    obstacleImg.resize(w, h);
    this.obstacleY = height-h;
  }

  void resizeFactor(float w, float h) { // Obstaclebild mit float-multiplizieren
    obstacleImg.resize(int(obstacleImg.width*w), int(obstacleImg.height*h));
    this.obstacleY = height-obstacleImg.height;
  }

  void showName() { // 
    showName = true;
  }

  abstract void collide(); // Abstrakte Funktion / Vorlage für alle Obstacles
}

//
//    Ab hier kommen die verschiedenen Obstacletypen die von der Hauptklasse erben
//

class Enemy extends Obstacle {  //////////////////////////////////////////////////////////////////////// ENEMY 

  Enemy(String obstacleName, String obstacleImage, int obstacleSpeed) {
    super(obstacleName, obstacleImage, obstacleSpeed);
  }

  void collide() {
    obstacles.remove(this);

    herzen--;
    damageSound.play();

    if (herzen <= 0) {
      loadGameData();
      coins+=score;
      if (highscore < score) highscore = score;
      saveGameData();
      obstacles.clear();
      gameState = 4;
      frameRate(60);
      createScreen(true); //DEBUG
    }
  }
}

class PowerUp extends Obstacle { //////////////////////////////////////////////////////////////////////// POWER UP 
  /*
    Effect 0 = Spieler wird hochgeschossen
   */
  int effect;
  PowerUp(String obstacleName, String obstacleImage, int obstacleSpeed, int effect) {
    super(obstacleName, obstacleImage, obstacleSpeed);
    this.effect = effect;
  }

  void collide() {
    obstacles.remove(this); // Obstacle wird nicht mehr angezeigt

    switch(effect) {
    case 0:
      player.speed = -600; // Spieler wird hochgespickt
      player.canJump = true; // Spieler kann nochmals springen
      break;
    }
  }
}

class Solid extends Obstacle {

  Solid(String obstacleName, String obstacleImage, int obstacleSpeed) {
    super(obstacleName, obstacleImage, obstacleSpeed);
  }

  void collide() {
  }
}

class Coin extends Obstacle { //////////////////////////////////////////////////////////////////////// COIN 

  Coin(String obstacleName, String obstacleImage, int obstacleSpeed) {
    super(obstacleName, obstacleImage, obstacleSpeed);
  }

  void collide() {
    score++; // Score um 1 höher
    coinSound.play();
    obstacles.remove(this);
  }
}
